<template>
    <div>
        <custom-card>
            <auto-datatable
                model="User"
                :filters="[
                    [
                        {label: $t('username'), name: 'f-like-username', type: 'text'},
                        {label: $t('introducer'), name: 'f-has-like-introducer-username', type: 'text'},
                    ],
                    [
                        {label: $t('name'), name: 'f-like-name', type: 'text'},
                        {label: $t('email'), name: 'f-email', type: 'text'}
                    ],
                    {
                        label: $t('country'),
                        name: 'f-has-country-id',
                        type: 'select',
                        options: countryOptions,
                    },
                    {
                        label: $t('ranking'),
                        name: 'f-ranking',
                        type: 'select', options: [
                            {value: '0', text: i18n.t('ranking_0')},
                            {value: '1', text: i18n.t('ranking_1')},
                            {value: '2', text: i18n.t('ranking_2')},
                            {value: '3', text: i18n.t('ranking_3')},
                        ]
                    },
                    [
                        {label: $t('created_at') + '(' + $t('from') + ')', name: 'f-date-from-created_at', type: 'date'},
                        {label: $t('created_at') + '(' + $t('to') + ')', name: 'f-date-to-created_at', type: 'date'},
                    ]
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('operation'), name: 'operation', sortable: false},
                    {label: $t('member_id'), name: 'member_id'},
                    {label: $t('ranking'), name: 'ranking', column: 'ranking_explained'},
                    {label: $t('introducer'), name: 'introducer_username', column: 'introducer_username'},
                    {label: $t('username'), name: 'username'},
                    {label: $t('name'), name: 'name'},
                    {label: $t('email'), name: 'email'},
                    {label: $t('credit_1'), name: 'credit_1'},
                    {label: $t('credit_2'), name: 'credit_2'},
                    {label: $t('investments'), name: 'total_investments', sortable: false},
                    {label: $t('created_at'), name: 'created_at'},
                ]"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div
                                class="flex justify-start space-x-2"
                            >
                                <auto-button
                                    :block="false"
                                    :icon="true"
                                    @click="loginAccount(record)"
                                >
                                    <font-awesome-icon icon="fa-solid fa-key" />
                                </auto-button>
                                <edit-button
                                    @click="model = record"
                                />
                            </div>
                        </td>
                        <td>{{ record.member_id }}</td>
                        <td>{{ record.ranking_explained }}</td>
                        <td>{{ record.introducer_username }}</td>
                        <td>{{ record.username }}</td>
                        <td>{{ record.name }}</td>
                        <td>{{ record.email }}</td>
                        <td>{{ $helper.fundFormat(record.credit_1) }}</td>
                        <td>{{ $helper.fundFormat(record.credit_2) }}</td>
                        <td>{{ $helper.fundFormat(record.total_investments) }}</td>
                        <td>{{ $helper.dateTimeFormat(record.created_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="model = null"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import AutoButton from "~/components/button/auto-button.vue";
import axios from "axios";
import {computed, inject, ref} from "vue";
import {useI18n} from "vue-i18n";
import EditButton from "~/components/button/edit-button.vue";
import PanelModal from "~/components/panel-modal.vue";
import ModelForm from "./model-form.vue";
import {useSettingStore} from "~/stores/setting.js";

const $helper = inject('$helper');
const $settingStore = useSettingStore();

const i18n = useI18n();
const model = ref(null);
const countryOptions = computed(() => {
    return $settingStore.countryForOptions || [];
});

const loginAccount = async (user) => {
    try {
        await $helper.alertConfirm({
            callback: async (result) => {
                if (result.isConfirmed) {
                    const data = await axios.post('/user/user/login_account', {
                        id: user.id,
                    });

                    localStorage.setItem('ut_token', `"${String(data.token)}"`);

                    location.href = '/';
                }
            }
        });
    } catch (e) {
        console.log(e);
    }
};
</script>
